#include <exec/types.h>

/* SAME ON EACH PLATFORM --------------------------------------------------

types */

typedef signed char  FLAG;   /* 8-bit signed quantity (replaces BOOL) */
typedef signed char  ABOOL;  /* 8-bit signed quantity (replaces BOOL) */
typedef signed char  SBYTE;  /* 8-bit signed quantity (replaces Amiga BYTE) */
typedef signed short SWORD;  /* 16-bit signed quantity (replaces Amiga WORD) */
typedef signed long  SLONG;  /* 32-bit signed quantity (same as LONG)

DIFFERING ON EACH PLATFORM ------------------------------------------------

types */

typedef signed char             COLOUR;         /* 8-bit signed */
typedef unsigned char		SCANCODE;	/* 8-bit unsigned

miscellaneous */

#define ABOUTXPIXEL              312
#define ABOUTYPIXEL              114
#define DEFAULTSET             "PROGDIR:WormWars.lset"
#define DELAY                  14000L
#define FONTX                      8 /* in pixels... */
#define FONTY                      8
#define HISCOREDISTANCE           13
#define SQUAREX                   12
#define SQUAREY                   12
#define STARTXPIXEL               83
#define STARTYPIXEL              (16 + TBSIZE)

/* scancodes */

#define ALPHAONE                0x01    /* row 1. alphabetic 1 */
#define ALPHATWO                0x02    /* row 1. alphabetic 2 */
#define ALPHATHREE              0x03    /* row 1. alphabetic 3 */
#define ALPHAFOUR               0x04    /* row 1. alphabetic 4 */
#define ALPHAFIVE               0x05    /* row 1. alphabetic 5 */
#define ALPHASIX                0x06    /* row 1. alphabetic 6 */
#define ALPHASEVEN              0x07    /* row 1. alphabetic 7 */
#define ALPHAEIGHT              0x08    /* row 1. alphabetic 8 */
#define ALPHANINE               0x09    /* row 1. alphabetic 9 */
#define ALPHAZERO               0x0A    /* row 1. alphabetic 0 */
#define NUMERICZERO             0x0F    /* row 5. numeric 0 */
#define Q                       0x10    /* row 2. */
#define W                       0x11    /* row 2. */
#define E                       0x12    /* row 2. erase */
#define R                       0x13    /* row 2. revert */
#define KEY_T                   0x14    /* row 2. teleport */
#define KEY_Y                   0x15    /* row 2. */
#define KEY_U                   0x16    /* row 2. */
#define I                       0x17    /* row 2. create icons? */
#define O                       0x18    /* row 2. open... */
#define P                       0x19    /* row 2. */
#define NUMERICONE              0x1D    /* row 5. numeric 1 */
#define NUMERICTWO              0x1E    /* row 5. numeric 2 */
#define NUMERICTHREE		0x1F	/* row 5. numeric 3 */
#define A                       0x20    /* row 3. save as... */
#define S                       0x21    /* row 3. save */
#define D                       0x22    /* row 3. delete */
#define F                       0x23    /* row 3. effects */
#define K                       0x27    /* row 3. */
#define INTERNATIONALONE	0x2B	/* row 3. international key adj. to
                                        Return (on some keyboards) */
#define NUMERICFOUR             0x2D    /* row 5. numeric 4 */
#define NUMERICFIVE             0x2E    /* row 5. numeric 5 */
#define NUMERICSIX              0x2F    /* row 5. numeric 6 */
#define INTERNATIONALTWO        0x30    // row 4. international key adj. to undo
#define Z                       0x31    /* row 4. */
#define KEY_X                   0x32    /* row 4. */
#define C                       0x33    /* row 4. */
#define V                       0x34    /* row 4. */
#define N                       0x36    /* row 4. new */
#define M                       0x37    /* row 4. music */
#define COMMA                   0x38    /* row 4. */
#define ALPHADOT                0x39    /* row 4. */
#define NUMERICDOT              0x3C    /* row 5. numeric . */
#define NUMERICSEVEN		0x3D	/* row 5. numeric 7 */
#define NUMERICEIGHT		0x3E	/* row 5. numeric 8 */
#define NUMERICNINE             0x3F    /* row 5. numeric 9 */
#define SPACEBAR                0x40    /* row 4. */
#define ENTER                   0x43    /* row 5. numeric Enter */
#define RETURN                  0x44    /* row 2. alphabetic Return */
#define ESCAPE                  0x45    /* row 0. */
#define DELETE                  0x46    /* row 3. */
#define NUMERICMINUS		0x4A	/* row 5. numeric - */
#define UP                      0x4C    /* row 1. */
#define DOWN                    0x4D    /* row 4. */
#define RIGHT                   0x4E    /* row 3. */
#define LEFT                    0x4F    /* row 2. */
#define F1                      0x50    /* row 0. */
#define F2                      0x51    /* row 0. */
#define F3                      0x52    /* row 0. */
#define F4                      0x53    /* row 0. */
#define F5                      0x54    /* row 0. */
#define F6                      0x55    /* row 0. */
#define F7                      0x56    /* row 0. */
#define F8                      0x57    /* row 0. */
#define F9                      0x58    /* row 0. */
#define F10                     0x59    /* row 0. */
#define NUMERICOPEN             0x5A    /* row 0. numeric ( */
#define NUMERICCLOSE		0x5B	/* row 0. numeric ) */
#define NUMERICSLASH		0x5C	/* row 5. numeric / */
#define NUMERICASTERISK		0x5D	/* row 5. numeric * */
#define NUMERICPLUS             0x5E    /* row 5. numeric + */
#define HELP                    0x5F    /* row 0. */
#define FIRSTQUALIFIER          0x60
#define LASTQUALIFIER		0x67
#define KEYUP                   0x80    /* key release */

/* colours */

#define BLACK		 0
#define LIGHTGREY        1 // Ideally white should be the 2nd colour. This
                           // enables the titlebar to render correctly.
#define DARKGREEN	 2
#define DARKYELLOW	 3
#define MEDIUMGREY	 4
#define DARKBLUE	 5
#define BLUE             6
#define GREEN		 7
#define DARKRED		 8
// brown is 9
#define RED             10
#define YELLOW		11
#define DARKGREY        12
#define ORANGE		13
#define PURPLE          14 // Ideally black should be the 2nd-last colour,
#define WHITE           15 // and white the last colour. This enables the
                           // menus to render correctly.

#define TBSIZE          11 // for Amiga only

/* Must have blank line at EOF. */
