* $Filename: WormWars/Source/qdraw020.asm
*
*  Copyright 2000 Jilles Tjoelker. Freely distributable.
*
* Worm Wars is  Copyright 1993-2003 James R. Jacobs. Freely distributable.
*        _
*       //		-=AMIGA=-
*      //
* _   //
* \\ //
*  \X/
*
* Assemble with PhxAss, see assemble.s.

             machine 68020

SQUAREX=12; <=16! ; <=32 can be done with a simple modification
SQUAREY=12; <=16! ; but >32 is more difficult

NPLANES=4 ; dynamic could be done easily

AnPInfo      equr a0
AnDPtr       equr a1
AnPOffset    equr a2
AnPPtr       equr a3

DnX          equr d0
DnData       equr d1
DnHeight     equr d2
DnPlane      equr d3
DnBPR        equr d4
DnScratch1   equr d5
DnPlaneSZ    equr d6

; - don't change d0-d1/a0-a1
; - # of BPR < # of PlaneSZ (for MOVEM)

regstosave   reg d2-d6/a2-a3 ; all of the above, except d0-d1/a0-a1

@qdraw020:
             xdef @qdraw020

; Prototype:
; void __asm qdraw020(register __a0 struct QDPlaneInfo *pi,register __d0 LONG x,register __d1 LONG y,register __a1 UWORD *data);
; or:
; void __regargs qdraw020(struct QDPlaneInfo *pi,LONG x,LONG y,WORD *data);

; The latter needs @qdraw020. (I've done that.)

; x&y are relative to screen bitmap, not window. Add window->TopEdge to y in C.
; The QDPlaneInfo contains information of the screen->RastPort.BitMap.

             rsreset
pi_Planes    rs.l NPLANES ; copy of bm_Planes[] element 0 to 3
pi_BPR       rs.l 1 ; bytesperrow
pi_PlaneSZ   rs.l 1 ; bytesperrow*rows

; struct QDPlaneInfo
; {
;            UWORD       *pi_Planes[4];
;            ULONG       pi_BPR,pi_PlaneSZ;
; };

             MOVEM.L regstosave,-(sp)

             MOVEM.L pi_BPR(AnPInfo),DnBPR/DnPlaneSZ ; # of BPR < # of PlaneSZ!

             MOVEQ #0,DnPlane

             *MOVE.L <y>,DnData ; already in there
             MULU.W DnBPR,DnData
             MOVEA.L DnData,AnPOffset

.planeloop:

             MOVEA.L pi_Planes(AnPInfo,DnPlane.L*4),AnPPtr
             ADDA.L AnPOffset,AnPPtr

             MOVEQ #SQUAREY-1,DnHeight

.yloop:
             MOVE.W (AnDPtr)+,DnData
             LSR.W #16-SQUAREX,DnData ; Image left-aligned <-> BFINS right-aligned
             BFINS DnData,(AnPPtr){DnX:SQUAREX}

             ADDA.L DnBPR,AnPPtr
             DBF DnHeight,.yloop

             ADDQ.W #1,DnPlane
             CMP.W #NPLANES,DnPlane
             BNE .planeloop

             MOVEM.L (sp)+,regstosave

             RTS
